program varosnezes;

uses
  SysUtils;

const
  MAXN = 50001;

var
  N, M, u, v, i: LongInt;
  P, indeg, DP, par: array[0..MAXN] of LongInt;
  adj: array[0..MAXN] of array of LongInt;
  q: array[0..MAXN] of LongInt;
  front, rear: LongInt;
  path: array[0..MAXN] of LongInt;
  pathLength: LongInt;

procedure AddEdge(u, v: LongInt);
begin
  SetLength(adj[u], Length(adj[u]) + 1);
  adj[u][High(adj[u])] := v;
end;

begin
  ReadLn(N, M);
  for i := 1 to N do
    Read(P[i]);
  for i := 1 to M do
  begin
    ReadLn(u, v);
    AddEdge(u, v);
  end;

  for i := 1 to N do
    indeg[i] := 0;

  front := 0;
  rear := 1;
  q[front] := 1;
  while front < rear do
  begin
    u := q[front];
    Inc(front);
    for i := 0 to High(adj[u]) do
    begin
      v := adj[u][i];
      if indeg[v] = 0 then
      begin
        q[rear] := v;
        Inc(rear);
      end;
      Inc(indeg[v]);
    end;
  end;

  for i := 1 to N do
  begin
    DP[i] := P[i];
    par[i] := -1;
  end;

  front := 0;
  rear := 1;
  q[front] := 1;
  while front < rear do
  begin
    u := q[front];
    Inc(front);

    for i := 0 to High(adj[u]) do
    begin
      v := adj[u][i];
      Dec(indeg[v]);
      if indeg[v] = 0 then
      begin
        q[rear] := v;
        Inc(rear);
      end;

      if DP[u] + P[v] > DP[v] then
      begin
        DP[v] := DP[u] + P[v];
        par[v] := u;
      end;
    end;
  end;

  if par[N] = -1 then
  begin
    WriteLn(-1);
    Exit;
  end;

  pathLength := 0;
  v := N;
  while v <> 1 do
  begin
    path[pathLength] := v;
    Inc(pathLength);
    v := par[v];
  end;
  path[pathLength] := 1;
  Inc(pathLength);

  WriteLn(DP[N]);
  for i := pathLength - 1 downto 0 do
  begin
    if i < pathLength - 1 then
      Write(' ');
    Write(path[i]);
  end;
  WriteLn;
end.
